function [A] = folding(An,n,ndim)
% function  [A] = folding(An,n,ndim)
%
%           Folding of a unfolding matrix into a n-th order tensor
%
% A      : n-th order tensor
% 
% An     : size(A,n)xsize(A,(n+1)mod3)size(A,(n+2)mod3) matrix unfolding n
% ndim  : Tensor dimensions

S=ndim;
O=length(S);

Odim=1:O;

%nOdim=[n,(n-1):-1:1,O:-1:(n+1)];
nOdim=circshift(Odim,[1 -(n-1)]);
nOdim=[nOdim(1) fliplr(nOdim(2:end))];
nS=S(nOdim);

B=reshape(An,nS);

A=ipermute(B,nOdim);
 