function [U] = hosvd(A)
% function  [U] = hosvd(A)
%
%           HOSVD of a 3rd order tensor
%
% A      : tensor
% 
% U      : n mode Singular matrix U(:,:,n)


global MatOct

S=size(A);
O=length(S);

[dim1,i1]=max(S);
[dim2,i2]=min(S);
dim2=prod(S)/S(i2);

An=zeros(dim1,dim2,O);
U=zeros(dim1,O);

for i=1:O
    ndim(i)=prod(S)/S(i);
    An(1:S(i),1:ndim(i),i)=unfolding(A,i);
    if MatOct==1
        [U(1:S(i),i),SIG,V]=svds(An(1:S(i),1:ndim(i),i),1);
    else
        [Ut,SIG,V]=svd(An(1:S(i),1:ndim(i),i));
        U(1:S(i),i)=Ut(:,1);
    end       
    %s(i,1:S(i))=diag(SIG);
end




