function [A] = outer_product(U,S)
% function  [A] = outer_product(U,dim)
%
%           outer product of n vectors of dimensions dim
%
% A      : Nth order tensor
% 
% U      : matrix of vectors


O=length(S);
SU=size(U);
dim=prod(S)/S(1);

Odim=1:O;
Udim=SU(1)*(Odim(1:end-1));

A=zeros(S);

dimi=(cumprod((S(1:end-1))));

for i=0:dim-1
    index=i*S(1)+1;
    ind=mod(floor(index./dimi),S(2:end));
    A(index:index+S(1)-1)=(U(1:S(1)))*prod(U(transpose(Udim+ind+1)));
end

