function [mu] = mon_mu (Y,f,g);

% [mu] = mon_mu (Y,f,g)

% Recuperation des dimensions
T = size(Y,2);

r = f'*Y;
dr = g'*Y;

% Calcul des coefficient des polynomes en mu
dr2 = dr.^2; r2 = r.^2;
P2 = [1/T*sum(dr2) 2/T*sum(r.*dr) 1/T*sum(r2)];
Q2 = polyder(P2);
P1 = [1/T*sum(dr.^4) 4/T*sum(r.*dr.^3) 6/T*sum(r2.*dr2) ...
        4/T*sum(r.^3.*dr) 1/T*sum(r.^4) ];
Q1 = polyder(P1);

A = conv(P2,Q1) - 2*conv(P1,Q2);

% Les mu optimaux candidats
mu = roots(A);
if 1-isreal(mu),
    %disp('ATTENTION: un mu candidat non reel');
    ind_garder = find(imag(mu)==0);
    mu = mu(ind_garder);
    %disp('OK, mu non reels supprimes!');
end;


% Calcul des couts

for k=1:length(mu)
    f_mu = f+mu(k)*g;
    cout(k) = CostKurtR(Y,f_mu);
end;

% Choix de mu optimal
[cou_max, mu_max] = max(cout);
mu = mu(mu_max);

% if isreal(mu)==0,
%     disp('AAAAAAAAAAAAAAAAARGH!');
%     disp('HORRRRRRRRRRRRRRRRRRRRRRRRRREURRRRRRRRRRRRRRRRRRRRRRRR');
%     disp('Le mu optimal n est pas reel');
%     disp('ESPECE DE -:#');
% end;
