function [w,crit] = GradientQuadR(epsilon,Nmax,y,z,f_ini,choix_mu,varargin);

% [W,crit] = GradientQuad(epsilon,Nmax,y,f_ini,choix_mu,varargin);
%%%passer en arg R et C (ou z pour calculer R et C)
%f = f_ini'; %on travaille en vecteur ligne
%critere sans la valeur absolue:
%    crit = f'*C*f;
%derivee par rapport a z:    
%    dc_df = C*conj(f);
%    par rapport a zbarre:   
%    dc_dfb = C*f;
%Solu1: à z fixé, faire un gradient
%Solu2: remettre à jour z à chaque pas de gradient
% je commence par le cas reel: crit = f.'*C*f / dc_df = (C+C.')*f = 2*C*f
% (ici C est symétrique)
%
% ici: cas reel crit = f.'*C*f/f.'*R*f


Nobserv = size(y,1);
D = length(f_ini)/Nobserv;

%Y = [];
%for ii = 1:D,
%%%    Y = [ Y; y(:,ii:end+ii-D)];
%    Y = [ y(:,ii:end+ii-D); Y];
%end;

f = f_ini';
[R,C] = makeRC(y,z,D); f = f/sqrt(f'*R*f);

%C = randn(size(C)); C= (C+C')/2;
iteration = 0;
dc_df =1;
if isnumeric(choix_mu),
    mu = choix_mu;
else 
    if nargin==7,
        mu = varargin{1};
    else
        mu = 1;
    end;
end;
   
%%%OLD%while ((norm(dc_df)/length(dc_df) > epsilon) & (iteration < Nmax)) | (iteration<50),
delta_f = 1;
%while iteration < Nmax,
while ((norm(delta_f)/length(dc_df) > epsilon) && (iteration < Nmax)) || (iteration<50),

    iteration = iteration + 1;
    
    crit_tmp = J(f,C,R);    %f.'*C*f/(f.'*R*f);
    dc_df = dJ(f,C,R);      %2*C*f/(f.'*R*f)-(f.'*C*f)/(f.'*R*f)^2*(2*R*f);
    
    crit = crit_tmp; %crit(iteration) = f.'*C*f;%crit_tmp;%%%
%        r = f'*Y;
%        cumu(iteration) = (1/length(Y)*sum(r.^4))/(1/length(Y)*sum(r.^2))^2 ;
    %ftot(:,iteration) = f;
    
    if choix_mu == 'optim',
        fRf = f.'*R*f; fCf = f.'*C*f;
        fRd = f.'*R*dc_df; fCd = f.'*C*dc_df;
        dRd = dc_df.'*R*dc_df; dCd = dc_df.'*C*dc_df;
        
        muposs = roots([dCd*fRd-dRd*fCd, dCd*fRf-dRd*fCf, fCd*fRf-fCf*fRd]);
        
        if J(f+muposs(1)*dc_df,C,R) > J(f+muposs(2)*dc_df,C,R),
            mu = - muposs(2);
        elseif J(f+muposs(2)*dc_df,C,R) > J(f+muposs(1)*dc_df,C,R),
        mu = -muposs(1);
        end;    

    elseif choix_mu == 'adapt',
        error('Adaptive step not implemented for ''quadraticGradient''. Use optimal step size instead (should perform better)');
    elseif isnumeric(choix_mu),
    end;
    
    newf = f - mu*dc_df;
    newf = newf/sqrt(newf'*R*newf);
    
    if J(newf,C,R) > crit(end),
        disp('Attention: non decroissance du critere');
%        if J(newf,C,R) > crit(end) + eps, keyboard; end;
    end;
    delta_f = f-newf;
    f = newf;

end;
%figure(2); plot(crit); title('crit'); pause;% keyboard; 
%plot(crit/var(z)); title('crit/var_z'); pause;
%plot(1:iteration,crit/var(z),'r',1:iteration,cumu,'b'); pause;

f = f'; % f est maintenant un vecteur ligne
w = f; %w = reshape(f,1,Nobserv,D); %W est sous format standard tableau 1 x Nobserv x D


function c = J(f,C,R)
    c = f.'*C*f/(f.'*R*f);
    
function d = dJ(f,C,R)
    d = 2*C*f/(f.'*R*f)-(f.'*C*f)/(f.'*R*f)^2*(2*R*f);
        
