function [w,crit] = ImprGradientQuadC2(epsilon,Nmax,y,z,f_ini,choix_mu,varargin)

% [W,crit] = GradientQuad(epsilon,Nmax,y,f_ini,choix_mu,varargin);
%%%passer en arg R et C (ou z pour calculer R et C)
%f = f_ini'; %on travaille en vecteur ligne
%critere sans la valeur absolue:
%    crit = f'*C*f;
%derivee par rapport a z:    
%    dc_df = C*conj(f);
%    par rapport a zbarre:   
%    dc_dfb = C*f;
%Solu1: à z fixé, faire un gradient
%Solu2: remettre à jour z à chaque pas de gradient
% je commence par le cas reel: crit = f.'*C*f / dc_df = (C+C.')*f = 2*C*f
% (ici C est symétrique)
%
% ici: cas complexe crit = |f'*C*f/f'*R*f|^2

Nobserv = size(y,1);
D = length(f_ini)/Nobserv;

f = f_ini';

[R,C] = makeRC(y,z,D); f = f/sqrt(f'*R*f);
C = (C+C')/2;

iteration = 0;
dc_df =1;
if isnumeric(choix_mu),
    mu = choix_mu;
else 
    if nargin==7,
        mu = varargin{1};
    else
        mu = 1;
    end;
end;
   
%%%OLD%while ((norm(dc_df)/length(dc_df) > epsilon) & (iteration < Nmax)) | (iteration<50),
delta_f = 1;
%while iteration < Nmax,
%while mu, iteration = 0;
%while ((norm(delta_f)/length(dc_df) > epsilon) && (iteration < Nmax)) || (iteration<50),
while ((norm(delta_f)/length(dc_df) > epsilon) && (iteration < Nmax)),

    iteration = iteration + 1;
    
    crit_tmp = J(f,C,R);    %f.'*C*f/(f.'*R*f);
    [dc_df,dc_dfb] = dJ(f,C,R);      %2*C*f/(f.'*R*f)-(f.'*C*f)/(f.'*R*f)^2*(2*R*f);
    crit(iteration) = crit_tmp;%%%
    critR(iteration) = f.'*C*f/(f.'*R*f);
    dcritR = 2*C*f/(f.'*R*f)-(f.'*C*f)/(f.'*R*f)^2*(2*R*f);
    
    if choix_mu == 'optim',
        fRf = f'*R*f; fCf = f'*C*f;
        fRd = (f'*R*dc_dfb + dc_dfb'*R*f)/2; fCd = (f'*C*dc_dfb + dc_dfb'*C*f)/2;
        dRd = dc_dfb'*R*dc_dfb; dCd = dc_dfb'*C*dc_dfb;
        
        muposs = roots([dCd*fRd-dRd*fCd, dCd*fRf-dRd*fCf, fCd*fRf-fCf*fRd]);
        if J(f+muposs(1)*dc_dfb,C,R) > J(f+muposs(2)*dc_dfb,C,R),
            mu = muposs(1);
        elseif J(f+muposs(2)*dc_dfb,C,R) > J(f+muposs(1)*dc_dfb,C,R),
            mu = muposs(2);
        end;
        
    elseif choix_mu == 'adapt',
        error('Adaptive step not implemented for ''quadraticGradient''. Use optimal step size instead (should perform better)');
    elseif isnumeric(choix_mu),
    end;
    
%    if iteration ==100, figure(1); plot(real(crit)); keyboard; end;
    newf = f + mu*dc_dfb;
    newf = newf/sqrt(newf'*R*newf);

    if J(newf,C,R) < crit(end),
        disp('Attention: non croissance du critere');
%        if J(newf,C,R) < crit(end) - eps, keyboard; end;
    end;
    
    delta_f = f-newf;
    f = newf;
    
end;
% mu = 0;
% figure(2); plot(crit); %keyboard; 
% mu = input('Encore?');
% end;

%%%figure(2); subplot(2,1,1); plot(real(crit)); subplot(2,1,2); plot(imag(crit)); %pause; %keyboard; 


f = f'; % f est maintenant un vecteur ligne
w = f; %w = reshape(f,1,Nobserv,D); %W est sous format standard tableau 1 x Nobserv x D


function c = J(f,C,R)
    c = abs(f'*C*f/(f'*R*f)).^2;
    
function [d,db] = dJ(f,C,R)
    d = 2*(f'*C*f/(f'*R*f)) * (C.'*conj(f)/(f'*R*f)-(f'*C*f)/(f'*R*f)^2*(R.'*conj(f)));
    db = conj(d);
